part of masamune;

extension WidgetRefEffectExtensions on WidgetRef {
  void effect({
    VoidCallback? onInitOrUpdate,
    VoidCallback? onDispose,
    List<Object> keys = const [],
  }) {
    return containerBuilder<_EffectContainer, void>(
      key: "effect",
      containerBuilder: (container) {
        onInitOrUpdate?.call();
        return _EffectContainer(
          onDispose: onDispose,
          keys: keys,
        );
      },
      resultBuilder: (container) {},
      test: (container) => container.keys != keys,
    );
  }
}

@immutable
class _EffectContainer extends VariableContainer {
  _EffectContainer({
    required this.onDispose,
    required this.keys,
  });

  final VoidCallback? onDispose;
  final List<Object> keys;

  @override
  void dispose() {
    onDispose?.call();
    super.dispose();
  }
}
