part of masamune;

extension WidgetRefMemoizedExtensions on WidgetRef {
  T useMemoized<T>(
    String key,
    T value, {
    List<Object> keys = const [],
  }) {
    return containerBuilder<_MemoizedContainer<T>, T>(
      key: "memoized:$key",
      containerBuilder: (container) {
        return _MemoizedContainer<T>(
          value: value,
          keys: keys,
        );
      },
      resultBuilder: (container) {
        return container.value;
      },
      test: (container) => container.keys != keys,
    );
  }
}

@immutable
class _MemoizedContainer<T> extends VariableContainer {
  _MemoizedContainer({
    required this.value,
    required this.keys,
  });

  final T value;
  final List<Object> keys;
}
