part of masamune;

extension WidgetRefScrollControllerExtensions on WidgetRef {
  ScrollController useScrollController({
    double initialScrollOffset = 0.0,
    bool keepScrollOffset = true,
    String? debugLabel,
  }) {
    return containerBuilder<_ScrollControllerContainer, ScrollController>(
      key: "scrollController",
      containerBuilder: (container) {
        final controller = ScrollController(
          initialScrollOffset: initialScrollOffset,
          keepScrollOffset: keepScrollOffset,
          debugLabel: debugLabel,
        );
        return _ScrollControllerContainer(
          controller: controller,
        );
      },
      resultBuilder: (container) {
        return container.controller;
      },
    );
  }
}

@immutable
class _ScrollControllerContainer extends VariableContainer {
  _ScrollControllerContainer({
    required this.controller,
  });

  final ScrollController controller;

  @override
  void didUpdateContainer(_ScrollControllerContainer oldContainer) {
    super.didUpdateContainer(oldContainer);
    if (controller != oldContainer.controller) {
      oldContainer.dispose();
    }
  }

  @override
  void dispose() {
    super.dispose();
    controller.dispose();
  }
}
