part of masamune;

extension WidgetRefValueNotifierExtensions on WidgetRef {
  ValueNotifier<T> useValueNotifier<T>(String key, T defaultValue) {
    return containerBuilder<_ValueNotifierContainer<T>, ValueNotifier<T>>(
      key: "valueNotifier:$key",
      containerBuilder: (container) {
        return _ValueNotifierContainer<T>(
          value: ValueNotifier<T>(defaultValue),
          defaultValue: defaultValue,
        );
      },
      resultBuilder: (container) {
        return container.value;
      },
      test: (container) => container.defaultValue != defaultValue,
    );
  }
}

@immutable
class _ValueNotifierContainer<T> extends VariableContainer {
  _ValueNotifierContainer({
    required this.value,
    required this.defaultValue,
  });

  final ValueNotifier<T> value;
  final T defaultValue;

  @override
  void initContainer() {
    super.initContainer();
    value.addListener(_handledOnUpdate);
  }

  @override
  void didUpdateContainer(_ValueNotifierContainer<T> oldContainer) {
    super.didUpdateContainer(oldContainer);
    if (value != oldContainer.value) {
      oldContainer.dispose();
    }
  }

  @override
  void dispose() {
    super.dispose();
    value.removeListener(_handledOnUpdate);
    value.dispose();
  }

  void _handledOnUpdate() {
    setState(() {});
  }
}
